
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_AGENT_SYMBOL_H
#define PG_AGENT_SYMBOL_H

#include "pgl/HostsBasedSym.h"
#include "base/UniqId.h"

class SocketSym;
class PopModelSym;

// base class for robot and server symbols
class AgentSym: public HostsBasedSym {
	public:
		AgentSym(const String &aType);
		AgentSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		String kind() const;
		UniqId world() const;
		SocketSym *socket() const;
		RndDistr *xactThink() const;
		RndDistr *pconnUseLmt() const;
		Time idlePconnTimeout() const;
		PopModelSym *popModel() const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
		RndDistr *namesToDistr(const String &fieldName, const Array<String*> &names) const;
};

#endif
