
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_PROXY_SERVER_XACTION_H
#define PG_PROXY_SERVER_XACTION_H

#include "server/SrvXact.h"
#include "cache/Cache.h"

class PxySrvXact: public SrvXact, public CacheReader {
	public:
		PxySrvXact() { PxySrvXact::reset(); }
		virtual void reset();

		virtual void noteWriteReady(int fd);
		virtual void noteWriterLeft();
		virtual void noteCacheReady();
		virtual const ReqHdr *origReqHdrs() const;

	protected:
		virtual Size put200OkBody(ostream &os);
		virtual bool setTarget(const NetAddr &target);
		virtual void newState(State aState);

		Size put200OkBodyHit(ostream &os);
		Size put200OkBodyMiss(ostream &os);

	protected:
		bool waitForCache;
};

#endif

