
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include "xstd/String.h"
#include "server/srvRepTypes.h"

// XXX: merge with CltReqTypesArr
class SrvRepTypesArr: public Array<String*> {
	public:
		SrvRepTypesArr();
		~SrvRepTypesArr();

	protected:
		String &str(int idx);
};

SrvRepTypesArr TheSrvRepTypeIdx;


SrvRepTypesArr::SrvRepTypesArr(): Array<String*>(rptEnd) {

	str(rptBasic)    = "Basic";
	str(rpt302Found) = "302 Found";

	// check that all are defined
	for (int i = 0; i < rptEnd; ++i)
		Assert(item(i) && *item(i));
}

SrvRepTypesArr::~SrvRepTypesArr() {
	while (count()) delete pop();
}

String &SrvRepTypesArr::str(int idx) {
	Assert(0 <= idx && idx < rptEnd);
	Assert(count() <= idx || !item(idx));
	put(new String, idx);
	return *item(idx);
}



const Array<String*> &SrvRepTypeIdx() {
	return TheSrvRepTypeIdx;
}
