
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef XSTD_NETWORK_INTERFACE_CLASS_H
#define XSTD_NETWORK_INTERFACE_CLASS_H

#include "xstd/String.h"
#include "xstd/Array.h"
#include "xstd/Socket.h"
#include "xstd/NetAddr.h"

// retreives a list of all interface addresses using SIOCGIFCONF or equiv
class NetIface {
	public:
		static bool GetAddrs(Array<in_addr> &addrs, const char *ifname = 0);

	public:
		NetIface();
		~NetIface();

		const String &name() const { return theName; }
		NetAddr primaryAddr() const;

		void name(const String &aName);
		void netmask(const in_addr &aNetmask);

		int delAliases(); // returns the number of aliases deleted or -1
		bool addAlias(const in_addr &addrs, int idx, in_addr netmask);
		bool addAliases(const Array<in_addr> &addrs, in_addr netmask);

	protected:
		void getAliases(Array<in_addr> &olds) const;

	protected:
		String theName;
		mutable Socket theSock;
};

#endif
